print(jit.version)

require("stuff/preamble")

local la2 = lib.la2
local ffi = lib.ffi

local sum = 0

local vec4 = la2.vec4
--~ local vec4 = require("test_PrePro_debug")()

local function test2()
	local N = 1000
	local vs = ffi.new("struct vec4[?]", N)
	for i = 0, N-1 do
		for j = 0, 3 do
			vs[i].arr[j] = math.random()
		end
	end
	for i = 0, N-1 do
		for j = i+1, N-1 do
			vs[i]:aadd(vs[j])
		end
		sum = sum + vs[i]:l2()
	end
end

function love.load()
	for i = 1, 3 do
		local gt = love.timer.getTime
		print("mem", collectgarbage("count"))
		local t = gt()
		for iters = 1, 10 do
			test2()
		end
		print("time", gt() - t)
		print("sum", sum)
	end
	love.event.quit()
end
