$ --local vecmeta = preRequire("templates/vecmeta.lua")
$ return function(N, M)
return function()

	local tp
	local meta = {}

$	preRequire("templates/vecmeta.lua")(N)

$	local altss = {
$		{"x","y","z","w"},
$		{"r","g","b","a"},
$	}

$	local structName = M and ("mat" .. tostring(M)) or ("vec" .. tostring(N))
$	local numType = "double"

	local tps = [[
	struct $(structName)$ {
	union {
		struct {
$			for i = 1, N do
				$(numType)$ i$(i)$;
$			end
		};
		struct {
			$(numType)$ arr[$(N)$];
		};
$		for _, alts in ipairs(altss) do
			struct {
$			for i = 1, math.min(#alts, N) do
				$(numType)$ $(alts[i])$;
$			end
			};
$		end
	};
	}
	]]
	
	local ffi = require("ffi")
	
	ffi.cdef(tps)

	meta.__index = meta

	tp = ffi.metatype("struct $(structName)$", meta)

	return tp

end
$ end
